'use strict';

var langJavascript = require('@codemirror/lang-javascript');
var language = require('@codemirror/language');
var common = require('@lezer/common');
var codemirrorLangGlimmer = require('codemirror-lang-glimmer');
var lr = require('@lezer/lr');
var highlight = require('@lezer/highlight');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const templateTagContent$1 = 8;

function matchForComment(commentEndPattern, commentToken, input) {
    for (let found = 0, i = 0;; i++) {
        if (input.next < 0) {
            if (i)
                input.acceptToken(commentToken);
            break;
        }
        let hasMatch = commentEndPattern[found] === input.next;
        if (!hasMatch) {
            found = 0;
            input.advance();
            break;
        }
        if (found === commentEndPattern.length - 1) {
            if (i > commentEndPattern.length - 1) {
                input.acceptToken(commentToken, 1 - commentEndPattern.length);
                break;
            }
            else {
                console.warn('Reached end of comment but there is still content left');
            }
            break;
        }
        found++;
        input.advance();
    }
}
const closingTemplateTag = '</template>'.split('').map((char) => char.charCodeAt(0));
const templateTagContent = new lr.ExternalTokenizer((input) => {
    return matchForComment(closingTemplateTag, templateTagContent$1, input);
});

const templateTagHighlighting = highlight.styleTags({
    TagName: highlight.tags.tagName,
    GlimmerTemplateTag: highlight.tags.tagName,
    TemplateTag: highlight.tags.tagName,
    Template: highlight.tags.tagName,
});

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "!^QQOQOOOVORO'#C^OOOO'#Ca'#CaQQOQOOOOOP'#Cb'#CbO_ORO,58xOOOO,58x,58xOOOO-E6_-E6_OOOP-E6`-E6`OOOO1G.d1G.d",
  stateData: "g~ORPO~OSUOWSO~OSXOWSO~O",
  goto: "hVPPWPP[bTQORQRORVRQTPRWT",
  nodeNames: "⚠ Document GlimmerTemplateTag TemplateTag TemplateTag",
  maxTerm: 8,
  nodeProps: [
    ["closedBy", 3,"templateTagEnd"],
    ["openedBy", 4,"templateTagStart"]
  ],
  propSources: [templateTagHighlighting],
  skippedNodes: [0],
  repeatNodeCount: 2,
  tokenData: "#s~RP!^!_U~XQ!P!Q_#h#i!l~bP#h#ie~hP#X#Yk~nP#a#bq~tP#d#ew~zP#`#a}~!QP#T#U!T~!WP#h#i!Z~!^P#X#Y!a~!dP!`!a!g~!lOS~~!oP#X#Y!r~!uP#a#b!x~!{P#d#e#O~#RP#`#a#U~#XP#T#U#[~#_P#h#i#b~#eP#X#Y#h~#kP!`!a#n~#sOR~",
  tokenizers: [templateTagContent, 0],
  topRules: {"Document":[0,1]},
  tokenPrec: 0
});

function gjs() {
    return new language.LanguageSupport(gjsLanguage, [codemirrorLangGlimmer.glimmer().support]);
}
function gts() {
    return new language.LanguageSupport(gtsLanguage, [codemirrorLangGlimmer.glimmer().support]);
}
const gtsLanguage = language.LRLanguage.define({
    parser: parser.configure({
        wrap: common.parseMixed((node) => {
            if (node.type.name === 'Document')
                return null;
            if (node.type.name === 'GlimmerTemplateTag') {
                return { parser: codemirrorLangGlimmer.glimmerLanguage.parser };
            }
            return { parser: langJavascript.typescriptLanguage.parser };
        }),
    }),
});
const gjsLanguage = language.LRLanguage.define({
    parser: parser.configure({
        wrap: common.parseMixed((node) => {
            if (node.type.name === 'Document')
                return null;
            if (node.type.name === 'GlimmerTemplateTag') {
                return { parser: codemirrorLangGlimmer.glimmerLanguage.parser };
            }
            return { parser: langJavascript.javascriptLanguage.parser };
        }),
    }),
});

exports.gjs = gjs;
exports.gjsLanguage = gjsLanguage;
exports.gts = gts;
exports.gtsLanguage = gtsLanguage;
